﻿using DG.Tweening;
using System;
using UnityEngine;

public class Capsizer : MonoBehaviour {

    public bool IsCapsized { get; private set; }

    [SerializeField] private float maxRotation;
    [SerializeField] private float capsizeDuration;

	public void Capsize(bool toRight, Action onComplete) {
        IsCapsized = true;
        float capsizeRotation = toRight ? -maxRotation : maxRotation;
        transform.DOKill();
        transform.DOLocalRotate(new Vector3(0.0f, 0.0f, capsizeRotation), 1.0f)
                 .OnComplete(() => {
                     CoroutineHelper.Delay(delegate () {
                         transform.DOLocalRotate(Vector3.zero, 1.0f)
                              .OnComplete(() => {
                                  IsCapsized = false;
                                  if (onComplete != null) {
                                      onComplete();
                                  }
                              });
                     }, capsizeDuration);
                 });
    }

}
