﻿using UnityEngine;

public class Drifter : MonoBehaviour {

    [SerializeField] private bool updateAltitude;
    [SerializeField] private bool updateRotation;
    [SerializeField] private float driftSize = .2f;
    [SerializeField] private float offsetY;

    private Sea sea;

    public void Drift() {
        if (updateAltitude) {
            Vector3 position = transform.position;
            position.y = sea.GetAltitudeAtPosition(position.x, position.z) + offsetY;
            transform.position = position;
        }

        if (updateRotation) {
            transform.localRotation = sea.GetRotationAtPosition(transform, driftSize);
        }
    }

    private void Awake() {
        sea = FindObjectOfType<Sea>();
    }

    private void Update() {
        Drift();
    }
	
}
