﻿using DG.Tweening;
using UnityEngine;

public class EndingStorm : Storm {

    public static bool IsStarted = false;

    public override void StartStorm(bool instant) {
        base.StartStorm(instant);

        IsStarted = true;

        FindObjectOfType<Lighthouse>().KeepDistance = false;

        Lighthouse environment = FindObjectOfType<Lighthouse>();
        Renderer[] envRenderers = environment.GetComponentsInChildren<Renderer>();
        foreach (Renderer r in envRenderers) {
            foreach (Material m in r.materials) {
                m.DOKill();
                m.DOColor(BackgroundColor, "_FadeColor", TransitionDuration * 2.0f);
                m.DOFloat(0.0f, "_FadeAmount", TransitionDuration * 2.0f);
                m.DOFloat(0.0f, "_Opacity", TransitionDuration);
            }
        }

    }

    private void Awake() {
        IsStarted = false;
    }

}
