﻿using UnityEngine;

public class Lighthouse : MonoBehaviour {

    public bool KeepDistance = true;

    [SerializeField] private Boat boat;
    [SerializeField] private float distance;
    [SerializeField] private float xDelay;

    private void Update() {
        Vector3 position = transform.position;
        if (KeepDistance) {
            position.z = boat.transform.position.z + distance;
        }
        position.x = Mathf.Lerp(position.x, boat.transform.position.x, 1.0f / xDelay);
        transform.position = position;
    }
	
}
