﻿using UnityEngine;

public class Steer : MonoBehaviour {

	[SerializeField] private Boat boat;

    [SerializeField] private float maxRotation;

    [SerializeField] private AudioSource steerAudio1;
    [SerializeField] private AudioSource steerAudio2;

    private float prevRotation;
    private bool playedAudio1;

    private void Update() {
        float rotation = -boat.SteerFactor * maxRotation;
        transform.localRotation = Quaternion.Euler(0.0f, rotation, 0.0f);

        if ((prevRotation == 0.0f && rotation != 0.0f) ||
            (prevRotation < 0.0f && rotation > 0.0f) ||
            (prevRotation > 0.0f && rotation < 0.0f)) {
            playedAudio1 = !playedAudio1;
            GetComponent<SoundEmitter>().PlayOnce(playedAudio1 ? steerAudio1 : steerAudio2);
        }

        prevRotation = rotation;
    }

}
