﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Timeline : MonoBehaviour {

    private List<Storm> storms;

    public Storm CurrentStorm { get { return storms[stormIndex % storms.Count]; } }

    private int stormIndex;

    private IEnumerator Start() {
        storms = new List<Storm>(GetComponentsInChildren<Storm>());
        storms.ForEach(x => x.gameObject.SetActive(false));
        storms.ForEach(x => x.OnDone += StartNextStorm);
        storms[0].StartStorm(true);
        storms[0].StopStorm();

        while (!Game.HasStarted) { yield return new WaitForEndOfFrame(); }

        storms[0].StartStorm(true);
    }

    private void Update() {
        if (Input.GetKeyDown(KeyCode.Backspace)) {
            StartNextStorm();
        }
    }

    private void StartNextStorm() {
        if (stormIndex + 1 >= storms.Count) { return; }
        CurrentStorm.StopStorm();
        stormIndex++;
        CurrentStorm.StartStorm(false);
    }

}