// Shader created with Shader Forge v1.32 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.32;sub:START;pass:START;ps:flbk:,iptp:0,cusa:False,bamd:0,lico:1,lgpr:1,limd:0,spmd:1,trmd:0,grmd:0,uamb:True,mssp:True,bkdf:False,hqlp:False,rprd:False,enco:False,rmgx:True,rpth:0,vtps:0,hqsc:True,nrmq:1,nrsp:0,vomd:0,spxs:False,tesm:0,olmd:1,culm:0,bsrc:0,bdst:1,dpts:2,wrdp:True,dith:0,rfrpo:True,rfrpn:Refraction,coma:15,ufog:False,aust:True,igpj:False,qofs:0,qpre:1,rntp:1,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.5,fgcg:0.5,fgcb:0.5,fgca:1,fgde:0.01,fgrn:0,fgrf:300,stcl:False,stva:128,stmr:255,stmw:255,stcp:6,stps:0,stfa:0,stfz:0,ofsf:0,ofsu:0,f2p0:False,fnsp:False,fnfb:False;n:type:ShaderForge.SFN_Final,id:3138,x:32719,y:32712,varname:node_3138,prsc:2|emission-806-OUT;n:type:ShaderForge.SFN_VertexColor,id:4746,x:31481,y:32654,varname:node_4746,prsc:2;n:type:ShaderForge.SFN_ValueProperty,id:1304,x:32133,y:33130,ptovrint:False,ptlb:FadeAmount,ptin:_FadeAmount,varname:node_1304,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:0;n:type:ShaderForge.SFN_FragmentPosition,id:7684,x:30788,y:32742,varname:node_7684,prsc:2;n:type:ShaderForge.SFN_ValueProperty,id:2194,x:30788,y:32895,ptovrint:False,ptlb:SeaGradientLength,ptin:_SeaGradientLength,varname:node_2194,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:2;n:type:ShaderForge.SFN_Color,id:6523,x:31481,y:32516,ptovrint:False,ptlb:SeaColor,ptin:_SeaColor,varname:node_6523,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_Clamp01,id:4610,x:31276,y:32859,varname:node_4610,prsc:2|IN-6325-OUT;n:type:ShaderForge.SFN_Divide,id:6325,x:31000,y:32808,varname:node_6325,prsc:2|A-7684-Y,B-2194-OUT;n:type:ShaderForge.SFN_Lerp,id:9786,x:31779,y:32707,varname:node_9786,prsc:2|A-905-RGB,B-4746-RGB,T-4610-OUT;n:type:ShaderForge.SFN_ViewPosition,id:1720,x:30839,y:33082,varname:node_1720,prsc:2;n:type:ShaderForge.SFN_Distance,id:1548,x:31079,y:33139,varname:node_1548,prsc:2|A-1720-XYZ,B-7684-XYZ;n:type:ShaderForge.SFN_ValueProperty,id:4661,x:30991,y:33485,ptovrint:False,ptlb:SeaGradientDistanceMin,ptin:_SeaGradientDistanceMin,varname:node_4661,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:5;n:type:ShaderForge.SFN_ValueProperty,id:5361,x:30991,y:33409,ptovrint:False,ptlb:SeaGradientDistanceMax,ptin:_SeaGradientDistanceMax,varname:node_5361,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:50;n:type:ShaderForge.SFN_Subtract,id:6489,x:31246,y:33250,varname:node_6489,prsc:2|A-1548-OUT,B-4661-OUT;n:type:ShaderForge.SFN_Subtract,id:1107,x:31246,y:33393,varname:node_1107,prsc:2|A-5361-OUT,B-4661-OUT;n:type:ShaderForge.SFN_Divide,id:6122,x:31464,y:33317,varname:node_6122,prsc:2|A-6489-OUT,B-1107-OUT;n:type:ShaderForge.SFN_Lerp,id:5438,x:31941,y:33053,varname:node_5438,prsc:2|A-4746-RGB,B-9786-OUT,T-6861-OUT;n:type:ShaderForge.SFN_Clamp01,id:6861,x:31683,y:33285,varname:node_6861,prsc:2|IN-6122-OUT;n:type:ShaderForge.SFN_Color,id:905,x:32133,y:32963,ptovrint:False,ptlb:FadeColor,ptin:_FadeColor,varname:node_905,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_Lerp,id:806,x:32429,y:32746,varname:node_806,prsc:2|A-5438-OUT,B-905-RGB,T-1304-OUT;proporder:1304-2194-6523-4661-5361-905;pass:END;sub:END;*/

Shader "Shader Forge/VertexColor" {
    Properties {
        _FadeAmount ("FadeAmount", Float ) = 0
        _SeaGradientLength ("SeaGradientLength", Float ) = 2
        _SeaColor ("SeaColor", Color) = (0.5,0.5,0.5,1)
        _SeaGradientDistanceMin ("SeaGradientDistanceMin", Float ) = 5
        _SeaGradientDistanceMax ("SeaGradientDistanceMax", Float ) = 50
        _FadeColor ("FadeColor", Color) = (0.5,0.5,0.5,1)
    }
    SubShader {
        Tags {
            "RenderType"="Opaque"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #include "UnityCG.cginc"
            #pragma multi_compile_fwdbase_fullshadows
            #pragma only_renderers d3d9 d3d11 glcore gles 
            #pragma target 3.0
            uniform float _FadeAmount;
            uniform float _SeaGradientLength;
            uniform float _SeaGradientDistanceMin;
            uniform float _SeaGradientDistanceMax;
            uniform float4 _FadeColor;
            struct VertexInput {
                float4 vertex : POSITION;
                float4 vertexColor : COLOR;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float4 posWorld : TEXCOORD0;
                float4 vertexColor : COLOR;
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.vertexColor = v.vertexColor;
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
////// Lighting:
////// Emissive:
                float3 emissive = lerp(lerp(i.vertexColor.rgb,lerp(_FadeColor.rgb,i.vertexColor.rgb,saturate((i.posWorld.g/_SeaGradientLength))),saturate(((distance(_WorldSpaceCameraPos,i.posWorld.rgb)-_SeaGradientDistanceMin)/(_SeaGradientDistanceMax-_SeaGradientDistanceMin)))),_FadeColor.rgb,_FadeAmount);
                float3 finalColor = emissive;
                return fixed4(finalColor,1);
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
    CustomEditor "ShaderForgeMaterialInspector"
}
