// Shader created with Shader Forge v1.32 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.32;sub:START;pass:START;ps:flbk:,iptp:0,cusa:False,bamd:0,lico:1,lgpr:1,limd:0,spmd:1,trmd:0,grmd:0,uamb:True,mssp:True,bkdf:False,hqlp:False,rprd:False,enco:False,rmgx:True,rpth:0,vtps:0,hqsc:True,nrmq:1,nrsp:0,vomd:0,spxs:False,tesm:0,olmd:1,culm:0,bsrc:3,bdst:7,dpts:2,wrdp:False,dith:0,rfrpo:True,rfrpn:Refraction,coma:15,ufog:False,aust:True,igpj:True,qofs:0,qpre:3,rntp:2,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.5,fgcg:0.5,fgcb:0.5,fgca:1,fgde:0.01,fgrn:0,fgrf:300,stcl:False,stva:128,stmr:255,stmw:255,stcp:6,stps:0,stfa:0,stfz:0,ofsf:0,ofsu:0,f2p0:False,fnsp:False,fnfb:False;n:type:ShaderForge.SFN_Final,id:3138,x:32719,y:32712,varname:node_3138,prsc:2|emission-5359-OUT,alpha-4540-OUT;n:type:ShaderForge.SFN_Color,id:4352,x:32029,y:32431,ptovrint:False,ptlb:FogColor,ptin:_FogColor,varname:node_4352,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.5,c2:0.5,c3:0.5,c4:1;n:type:ShaderForge.SFN_ValueProperty,id:9780,x:31720,y:33099,ptovrint:False,ptlb:AltitudeStart,ptin:_AltitudeStart,varname:node_9780,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:4;n:type:ShaderForge.SFN_ValueProperty,id:4777,x:31720,y:33000,ptovrint:False,ptlb:AltitudeEnd,ptin:_AltitudeEnd,varname:node_4777,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:8;n:type:ShaderForge.SFN_FragmentPosition,id:160,x:31720,y:32837,varname:node_160,prsc:2;n:type:ShaderForge.SFN_Subtract,id:8135,x:31913,y:32875,varname:node_8135,prsc:2|A-160-Y,B-9780-OUT;n:type:ShaderForge.SFN_Subtract,id:6778,x:31913,y:33018,varname:node_6778,prsc:2|A-4777-OUT,B-9780-OUT;n:type:ShaderForge.SFN_Divide,id:9379,x:32118,y:32961,varname:node_9379,prsc:2|A-8135-OUT,B-6778-OUT;n:type:ShaderForge.SFN_Clamp01,id:4836,x:32118,y:33099,varname:node_4836,prsc:2|IN-9379-OUT;n:type:ShaderForge.SFN_Lerp,id:5359,x:32326,y:32753,varname:node_5359,prsc:2|A-4352-RGB,B-4474-RGB,T-4836-OUT;n:type:ShaderForge.SFN_Color,id:4474,x:32029,y:32643,ptovrint:False,ptlb:SolidColor,ptin:_SolidColor,varname:node_4474,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0.3897059,c2:0.3897059,c3:0.3897059,c4:1;n:type:ShaderForge.SFN_ValueProperty,id:4540,x:32118,y:33278,ptovrint:False,ptlb:Opacity,ptin:_Opacity,varname:node_4540,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,v1:1;proporder:4352-9780-4777-4474-4540;pass:END;sub:END;*/

Shader "Shader Forge/LighthouseShader" {
    Properties {
        _FogColor ("FogColor", Color) = (0.5,0.5,0.5,1)
        _AltitudeStart ("AltitudeStart", Float ) = 4
        _AltitudeEnd ("AltitudeEnd", Float ) = 8
        _SolidColor ("SolidColor", Color) = (0.3897059,0.3897059,0.3897059,1)
        _Opacity ("Opacity", Float ) = 1
        [HideInInspector]_Cutoff ("Alpha cutoff", Range(0,1)) = 0.5
    }
    SubShader {
        Tags {
            "IgnoreProjector"="True"
            "Queue"="Transparent"
            "RenderType"="Transparent"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            Blend SrcAlpha OneMinusSrcAlpha
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #include "UnityCG.cginc"
            #pragma multi_compile_fwdbase
            #pragma only_renderers d3d9 d3d11 glcore gles 
            #pragma target 3.0
            uniform float4 _FogColor;
            uniform float _AltitudeStart;
            uniform float _AltitudeEnd;
            uniform float4 _SolidColor;
            uniform float _Opacity;
            struct VertexInput {
                float4 vertex : POSITION;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float4 posWorld : TEXCOORD0;
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
////// Lighting:
////// Emissive:
                float3 emissive = lerp(_FogColor.rgb,_SolidColor.rgb,saturate(((i.posWorld.g-_AltitudeStart)/(_AltitudeEnd-_AltitudeStart))));
                float3 finalColor = emissive;
                return fixed4(finalColor,_Opacity);
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
    CustomEditor "ShaderForgeMaterialInspector"
}
